<template>
    <div class="container">
        <div class="row" v-if="$gate.isAdminOrAuthor()">
          <div class="col-12">
            <div class="card">
              <div class="card-header">
                <h3 class="card-title">Users List</h3>

                <div class="card-tools">
                  <button type="button" class="btn btn-default" @click="newModal">Add <i class="fas fa-user-plus"></i></button>
                  

                </div>
              </div>
              <!-- /.card-header -->
              <div class="card-body table-responsive p-0">
                <table class="table table-hover">
                  <tbody><tr>
                    <th>ID</th>
                    <th>Name</th>
                    <th>Email</th>
                    <th>Type</th>
                    <th>Registered At</th>
                    <th>Modify</th>
                  </tr>
                    <tr v-for="user in users.data" :key="user.id">
                        <td>{{user.id}}</td>
                        <td>{{user.name | upText}}</td>
                        <td>{{user.email}}</td>
                        <td>{{user.type | upText}}</td>
                        <td>{{user.created_at | myDate}}</td>
                        <td>
                            <button type="button" class="btn btn-primary" @click="editModal(user)">Edit <i class="fas fa-user-edit"></i></button>
                            <button type="button" class="btn btn-danger" @click="deleteUser(user.id)">Delete <i class="fas fa-trash"></i></button>
                        </td>
                    </tr>
                  
                </tbody></table>
              </div>
               <div class="card-footer">
                  <pagination :data="users" @pagination-change-page="getResults"></pagination>
              </div>

              <!-- /.card-body -->
            </div>
            <!-- /.card -->
          </div>
        </div>
        <div v-if="!$gate.isAdminOrAuthor()">
            <not-found></not-found>
        </div>


        <!-- Modal -->
        <div class="modal fade" id="newModal" tabindex="-1" role="dialog" aria-labelledby="addNewTitle" aria-hidden="true">
          <div class="modal-dialog modal-dialog-centered" role="document">
            <div class="modal-content">
              <div class="modal-header">
                <h5 class="modal-title" v-show="!editmode" id="addNewLabel">Add New</h5>
                <h5 class="modal-title" v-show="editmode" id="addNewLabel">Update User's Info</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                  <span aria-hidden="true">&times;</span>
                </button>
              </div>
                <form @submit.prevent="editmode ? updateUser() : createUser()">
                    <div class="modal-body">
                        <div class="form-group">
                          <input v-model="form.name" type="text" name="name" placeholder="Enter name" 
                            class="form-control" :class="{ 'is-invalid': form.errors.has('name') }">
                          <has-error :form="form" field="name"></has-error>
                        </div>
                        <div class="form-group">
                          <input v-model="form.email" type="text" name="email" placeholder="Enter email" 
                            class="form-control" :class="{ 'is-invalid': form.errors.has('email') }">
                          <has-error :form="form" field="email"></has-error>
                        </div>
                       
                        <div class="form-group">
                            <textarea v-model="form.bio" name="bio" placeholder="Enter bio" class="form-control" :class="{ 'is-invalid': form.errors.has('bio') }"></textarea>
                          <has-error :form="form" field="bio"></has-error>
                        </div>
                        <div class="form-group">
                            <select class="form-control" name="type" v-model="form.type" id="type" :class="{ 'is-invalid': form.errors.has('bio') }">
                                <option value="">Select user role</option>
                                <option value="admin">Admin</option>
                                <option value="user">Statndard User</option>
                                <option value="author">Author</option>
                                <option value="user">User</option>
                            </select>
                         
                          <has-error :form="form" field="type"></has-error>
                        </div>
                        <div class="form-group">
                          <input v-model="form.password" type="text" name="password" placeholder="Enter password" 
                            class="form-control" :class="{ 'is-invalid': form.errors.has('password') }">
                          <has-error :form="form" field="password"></has-error>
                        </div>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-danger" data-dismiss="modal">Close</button>
                        <button v-show="editmode" type="submit" class="btn btn-success">Update</button>
                        <button v-show="!editmode" type="submit" class="btn btn-primary">Create</button>
                    </div>
                </form>
            </div>
          </div>
        </div>
    </div>
</template>

<script>
    export default {
        data () {
            return {             
                // users empty array
              editmode: false,
              users : {},
              // Create a new form instance

                form: new Form({
                    id:'',
                    name: '',
                    email: '',
                    password: '',
                    type: '',
                    bio: '',
                    photo: '',
                  })
                }
        },
        methods: {
            newModal(){
              this.editmode = false;
              this.form.reset();
              $('#newModal').modal('show');
            },
            editModal(user){
              this.editmode = true;
              this.form.reset();
              $('#newModal').modal('show');
              this.form.fill(user);
            },
            loadUsers(){
              if(this.$gate.isAdminOrAuthor()){

                this.$Progress.start()
                axios.get("api/user").then(({ data }) => (this.users = data));
                toast.fire({
                      type: 'success',
                      title: 'Users load successfully'
                    })
                this.$Progress.finish()
              }
              
            },
            // Our method to GET results from a Laravel endpoint
            getResults(page = 1) {
               axios.get('api/user?page=' + page)
                        .then(response => {
                            this.users = response.data;
                    });
            },
            searchUser(query, page=1){
              axios.get('api/findUser?q=' + query+ '&page='+ page)
                    .then((data) => {
                        this.users = data.data
                    })
                    .catch(() => {

              })
            },
            createUser () {
              // Submit the form via a POST request
                this.$Progress.start()
                this.form.post('api/user')
                    .then(({ data }) => { 
                        $('#newModal').modal('hide');
                        toast.fire({
                          type: 'success',
                          title: 'User Created successfully'
                        })
                        Fire.$emit('AfterCreateUser');
                        this.$Progress.finish()

                    })
                    .catch(()=>{
                        this.$Progress.fail()
                    })
            },
            updateUser(){
                this.$Progress.start();
                  // console.log('Editing data');
                  this.form.put('api/user/'+this.form.id)
                  .then(() => {
                      // success
                        $('#newModal').modal('hide');
                        Fire.$emit('AfterCreateUser');
                        Swal.fire(
                          'Good job!',
                          'Info has been updated !',
                          'success'
                        )
                        this.$Progress.finish();  
                  })
                  .catch(() => {
                      this.$Progress.fail();
                  });
            },
            deleteUser(id){
                Swal.fire({
                  title: 'Are you sure?',
                  text: "You won't be able to revert this!",
                  type: 'warning',
                  showCancelButton: true,
                  confirmButtonColor: '#3085d6',
                  cancelButtonColor: '#d33',
                  confirmButtonText: 'Yes, delete it!'
                }).then((result) => {
                    // send ajax request to server
                    if (result.value) {
                      this.form.delete('api/user/'+ id).then(()=> {
                            Fire.$emit('AfterCreateUser');
                            Swal.fire(
                                'Deleted!',
                                'Your file has been deleted.',
                                'success'
                              )
                            
                      }).catch((e)=>{
                          console.log(e);
                          Swal.fire(
                                'Failed!',
                                'Somewent wrong.',
                                'success'
                              )

                      });

                    }
                      

                })

            },
        },
        mounted() {
            console.log('User mounted.')
            Fire.$on('searching',() => {
               let query = this.$parent.search;
               this.searchUser(query);
            })

            this.loadUsers();
            Fire.$on('AfterCreateUser', ()=> {
              this.loadUsers();
            });
        }
    };
</script>
